import { type PropType } from 'vue';
import type { AllItems, Item, FocusHook, SelectHook, UnfocusHook, DOMFocusHook, ItemDefaults, NullablePartial } from './types';
export declare type Context = {
    focusNext(): void;
    focusPrevious(): void;
    clearFocus(): void;
    setFocusByKey(key?: string | null | undefined): void;
    setFocusByIndex(index: number): void;
    onSelect(fn: SelectHook): void;
    onFocus(fn: FocusHook): void;
    onUnfocus(fn: UnfocusHook): void;
    onDOMFocus(fn: DOMFocusHook): void;
    getItemMetaByKey<Meta = any>(key: string): Meta | undefined;
    getSelectableItemCount(): number;
    getSelectableItems<Meta = unknown>(): Item<Meta>[];
    selectFocusedItem(): void;
    getFocusedItem<Meta = unknown>(): Item<Meta> | undefined;
    getItemElementByKey(key: string): HTMLElement | undefined;
    getItemElementByIndex(index: number): HTMLElement | undefined;
    scrollToFocusedItemElement(options?: ScrollIntoViewOptions): void;
    getFocusedItemElement(): HTMLElement | undefined;
};
export interface Props {
    noWrapperElement: boolean;
    items: AllItems[];
    setup(context: Context): void;
    itemDefaults: NullablePartial<ItemDefaults>;
    onSelect: SelectHook;
    onItemFocus: FocusHook;
    onItemUnfocus: UnfocusHook;
    onItemDOMFocus: DOMFocusHook;
}
declare const _default: import("vue").DefineComponent<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems<any>[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: Context) => void>;
        default: any;
    };
    itemDefaults: {
        type: PropType<NullablePartial<ItemDefaults>>;
        default: () => {};
    };
}, {
    handleDOMFocus: (event: FocusEvent, item: Item<unknown>) => void;
    handleMouseEnter: (item: Item) => void;
    handleClick: (item: Item) => void;
    isFocused: (key: string) => boolean;
    isDisabled: (key: string) => boolean;
    setFocusByKey: (key: string, byPointer?: boolean) => void;
    selectItem: (key: string) => void;
    saveSelectableItemElement: (key: string, element: HTMLElement) => any;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    select: import("./types").Hook;
    itemFocus: FocusHook;
    itemUnfocus: import("./types").Hook;
    itemDOMFocus: DOMFocusHook;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    noWrapperElement: {
        type: PropType<boolean>;
        default: boolean;
    };
    items: {
        type: PropType<AllItems<any>[]>;
        default: () => any[];
    };
    setup: {
        type: PropType<(context: Context) => void>;
        default: any;
    };
    itemDefaults: {
        type: PropType<NullablePartial<ItemDefaults>>;
        default: () => {};
    };
}>> & {
    onSelect?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
    onItemFocus?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement, byPointer: boolean) => any;
    onItemUnfocus?: (meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
    onItemDOMFocus?: (event: FocusEvent, meta: any, item: Item<any, unknown, unknown, Record<string, unknown>, {
        key?: undefined;
        ref?: import("vue").Ref<HTMLElement> | ((el: HTMLElement) => void);
    } & Record<string, unknown>>, el: HTMLElement) => any;
}, {
    noWrapperElement: boolean;
    items: AllItems<any>[];
    setup: (context: Context) => void;
    itemDefaults: {};
}>;
export default _default;
