import { type Component } from 'vue';
import type { AllItems, CustomItem, CustomItemOptions, Item, ItemDefaults, ItemGroup, ItemGroupOptions, ItemOptions, NullablePartial } from './types';
export declare function itemGroup<WrapperComponent>(options: ItemGroupOptions<WrapperComponent>): ItemGroup<WrapperComponent>;
export declare function item<Meta = unknown, WrapperComponent = unknown, ElementTag = unknown>(options: ItemOptions<Meta, WrapperComponent, ElementTag>): Item<Meta, WrapperComponent, ElementTag>;
export declare function customItem<Meta = unknown>(options: CustomItemOptions<Meta>): CustomItem<Meta>;
export declare function isObject(value: unknown): value is Record<string | number | symbol, unknown>;
export declare function isString(value: unknown): value is string;
export declare function isFunction<T = (...args: unknown[]) => unknown>(value: unknown): value is T;
export declare function hasOwn(obj: unknown, property: string): boolean;
export declare function isComponentOrTag(value: unknown): value is Component | string;
export declare function isItemGroup(value: unknown): value is ItemGroup;
export declare function isItem<Meta = unknown>(value: unknown): value is Item<Meta>;
export declare function isCustomItem<Meta = unknown>(value: unknown): value is CustomItem<Meta>;
export declare function isComponent(value: unknown): value is Component;
export declare function filterSelectableAndCustomItems<Meta = unknown>(items: AllItems<Meta>[]): (Item<Meta> | CustomItem<Meta>)[];
export declare function filterSelectableItems<Meta = unknown>(items: AllItems<Meta>[]): Item<Meta>[];
export declare function isOr<Value, Or>(value: Value, is: (value: unknown) => boolean, or: Or): Value | Or;
export declare function createItemDefaults({ elementAttrs, elementTag, wrapperComponentOrTag, wrapperProps, }?: NullablePartial<ItemDefaults>): NullablePartial<ItemDefaults>;
